# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/pinctrl/amlogic,meson8-pinctrl-aobus.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Amlogic Meson8 AOBUS pinmux controller

maintainers:
  - Neil Armstrong <neil.armstrong@linaro.org>

allOf:
  - $ref: amlogic,meson-pinctrl-common.yaml#

properties:
  compatible:
    oneOf:
      - enum:
          - amlogic,meson8-aobus-pinctrl
          - amlogic,meson8b-aobus-pinctrl
          - amlogic,meson-gxbb-aobus-pinctrl
          - amlogic,meson-gxl-aobus-pinctrl
          - amlogic,meson-axg-aobus-pinctrl
      - items:
          - const: amlogic,meson8m2-aobus-pinctrl
          - const: amlogic,meson8-aobus-pinctrl

required:
  - compatible

patternProperties:
  "^bank@[0-9a-z]+$":
    $ref: amlogic,meson-pinctrl-common.yaml#/$defs/meson-gpio

    unevaluatedProperties: false

    properties:
      reg:
        maxItems: 3

      reg-names:
        items:
          - const: mux
          - const: pull
          - const: gpio

      gpio-line-names:
        minItems: 11 # GXL
        maxItems: 16 # Meson8

unevaluatedProperties:
  type: object
  $ref: amlogic,meson-pinctrl-common.yaml#/$defs/meson-pins

examples:
  - |
    pinctrl_aobus: pinctrl {
      compatible = "amlogic,meson8-aobus-pinctrl";
      #address-cells = <1>;
      #size-cells = <1>;
      ranges;

      bank@14 {
        reg = <0x14 0x4>,
              <0x2c 0x4>,
              <0x24 0x8>;
        reg-names = "mux", "pull", "gpio";
        gpio-controller;
        #gpio-cells = <2>;
        gpio-ranges = <&pinctrl_aobus 0 0 16>;
      };

      cec_ao_a_h_pins: cec_ao_a_h {
        mux {
          groups = "cec_ao_a_h";
          function = "cec_ao_a_h";
          bias-disable;
        };
      };
    };
